SystemOrganization addCategory: #'Xenon-Examples-Fibonacci'!
SystemOrganization addCategory: #'Xenon-Examples-Factorial'!

Object subclass: #XeImperativeFactorial
	uses: XeTStdio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Factorial'!

!XeImperativeFactorial commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Factorial
without recursion
!

XeImperativeFactorial class
	uses: XeTStdio classTrait
	instanceVariableNames: ''!

!XeImperativeFactorial methodsFor: 'c code' stamp: 'BernardoContreras 6/13/2012 00:32'!
factorial: x
	<returnType: #int>
	<var: #x type: #int>
	<var: #result type: #int>
	<var: #i type: #int>
	| result i |
	result := 1.
	i := 1.
	[ i <= x ]
		whileTrue: [ 
			result := result * i.
			i := i + 1 ].
	^ result! !

!XeImperativeFactorial methodsFor: 'c code' stamp: 'BernardoContreras 6/16/2012 23:38'!
main
	^ self factorial: 12
	! !

Object subclass: #XeImperativeFibonacci
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Fibonacci'!

!XeImperativeFibonacci commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Fibonacci_number
without recursion
!

!XeImperativeFibonacci methodsFor: 'c code' stamp: 'BernardoContreras 6/13/2012 20:56'!
fib: n
	<returnType: #int>
	<var: #n type: #int>
	<var: #fibOne type: #int>
	<var: #fibTwo type: #int>
	<var: #result type: #int>
	<var: #i type: #int>
	
	| i fibOne fibTwo result |
	i := 2.
	fibOne := 0.
	fibTwo := 1.
	n =  0
		ifTrue: [ ^ fibOne ].
	n =  1
		ifTrue: [ ^ fibTwo ].
	[ i <= n ]
		 whileTrue: [  
			result := fibOne + fibTwo.
			fibOne := fibTwo.
			fibTwo := result.
			i  :=  i + 1.
				 ].
	^ result.! !

Object subclass: #XeRecursiveFactorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Factorial'!

!XeRecursiveFactorial commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Factorial
with recursion
!

!XeRecursiveFactorial methodsFor: 'c code' stamp: 'BernardoContreras 6/10/2012 00:14'!
factorial: x
	<returnType: #int>
	<var: #x type: #int>
	x = 0
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ x * (self factorial: x - 1) ]! !

Object subclass: #XeRecursiveFibonacci
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Examples-Fibonacci'!

!XeRecursiveFibonacci commentStamp: '<historical>' prior: 0!
http://en.wikipedia.org/wiki/Fibonacci_number
with recursion
!

!XeRecursiveFibonacci methodsFor: 'c code' stamp: 'BernardoContreras 6/10/2012 00:37'!
fib: x
	<returnType: #int>
	<var: #x type: #int>
	x = 0
		ifTrue: [ ^ 1 ].
	x = 1
		ifTrue: [ ^ 1 ].
	^ (self fib: x - 1) + (self fib: x - 2)! !
